import os
import sys
import string
import copy
import stat
import mimetypes
import libxml2
import libxslt
import cStringIO

import ensimapplpath
from rfcdate import rfc1123_date
import skin
import dashboard
import requestutil
import convertunits
import fileman
import sessionman
#Webppliance Type Check
import egv
import xml.dom.minidom
import xmlhelper
from skin_gui_35 import AA_menu_items,RA_menu_items,\
                        SA_menu_items,UA_menu_items,\
                        AA_shortcuts,AA_shortcuts_basic,RA_shortcuts,\
                        SA_shortcuts,UA_shortcuts,blank_cell

tbl_width = 3

_site_main_filename = os.path.join(skin.SKINS_DIR,
                                   skin.get_current_skin(),
                                   'html',
                                   'site_main.xsl')
site_main_doc, site_main, site_main_stat = None, None, None

_need_site_main_reload = 'need_reload'

def cache_load_site_xsl():
    global site_main_doc
    global site_main_stat
    global site_main
    global _site_main_filename
    try:
        if site_main == None:
            raise _need_site_main_reload
        new_stat = os.stat(_site_main_filename)[stat.ST_MTIME]
        if new_stat > site_main_stat:
            site_main.freeStylesheet()
            raise _need_site_main_reload
    except _need_site_main_reload:
        site_main_stat = os.stat(_site_main_filename)[stat.ST_MTIME]
        site_main_doc = libxml2.parseFile(_site_main_filename)
        site_main = libxslt.parseStylesheetDoc(site_main_doc)
        return
    return


def get_misc_site_data(conf):
    newconf = {}
    # ipinfo
    if int(conf['ipinfo']['namebased']) == 1:
        newconf['ip_addr'] = string.join(conf['ipinfo']['nbaddrs'],',')
    else:
        newconf['ip_addr'] = string.join(conf['ipinfo']['ipaddrs'],',')
    newconf.update({'apache_htmlpath': dashboard.get_html_root(conf),
                    'apache_cgipath': dashboard.get_cgi_root(conf)})
    return newconf
    
def menu_item(skinobj, in_menu_item, filterobj, indented):
    r = skinobj.get_response()

    # draws navbar item
    # - must take into account whether the item has a href link (so
    # display it as a link or a static link)
    # - must replace the placeholder '%(lang)s' -> en_US, fr_FR, etc...
    in_menu_item['translated_caption'] = skinobj.T_(in_menu_item['caption'])
    if not indented:
        r.write('''
  <table width="166" height="16" border="0" cellpadding="0" cellspacing="0" background="images/clear.gif">
    <tr>
      <td background="images/butn_mainnav.gif">
        <table border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td width="6"><img src="images/clear.gif" width="1" height="1"/></td>
            <td width="6"><img src="images/clear.gif" width="1" height="1"/></td>''')
    else:
        r.write('''
  <table width="166" height="15" border="0" cellpadding="0" cellspacing="0" background="images/clear.gif">
    <tr>''')
        if in_menu_item.has_key('border_item') and \
           in_menu_item['border_item'] == 1: # first item of submenus
            r.write('''
      <td align="right" background="images/butn_subnav1.gif">''')
        elif in_menu_item.has_key('border_item') and \
           in_menu_item['border_item'] == 2: # last item of submenus
            r.write('''
      <td align="right" background="images/butn_subnav3.gif">''')
        else:
            r.write('''
      <td align="right" background="images/butn_subnav2.gif">''')
        r.write('''
        <table width="151" border="0" cellpadding="0" cellspacing="0" background="images/clear.gif">
          <tr> ''')

    if in_menu_item.has_key('href'):
        in_menu_item['href_final'] = \
            in_menu_item['href'] % {'lang': skinobj.get_lang()}
        if in_menu_item.has_key('target'):
            in_menu_item['target_final'] = in_menu_item['target']
        else:
            in_menu_item['target_final'] = 'main'
        if not indented:
            r.write('''
            <td class="Utxt1"><a href="%(href_final)s" target=%(target_final)s>%(translated_caption)s</a></td>''' % in_menu_item)
        else:
            r.write('''
            <td width="129" class="Utxt1"><a href="%(href_final)s" target=main>%(translated_caption)s</a>''' % in_menu_item)
            if in_menu_item.has_key('icon'):
                r.write(' <img src="%(icon)s" width="12" height="7"/>' % \
                        in_menu_item)
            r.write('</td>')
            r.write('''
            <td width="22"><img src="images/sysoption_on.gif" width="18" height="9"></td>''')
    else:
        r.write('''
            <td class="Utxt3Bold">%(translated_caption)s</td>''' % \
                in_menu_item)
    r.write('''
          </tr>
        </table>
      </td>
    </tr>
  </table>''')
    
def dict_to_menu(skinobj, in_menu_items, filterobj, caption,
                 css):
    r = skinobj.get_response()
    r.write('''
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=%(charset)s">
<link href="%(css)s" rel="stylesheet" type="text/css">
</head>

<body background="images/fill_nav-background.gif" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<table width="199" height="47" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td valign="top" background="images/nav_header.gif">
      <table width="169" border="0" cellpadding="0" cellspacing="0" background="images/clear.gif">
        <tr> 
          <td><img src="images/clear.gif" width="1" height="14"/></td>
        </tr>
        <tr>
          <td align="right" class="Utxt1Bold">%(T_CAPTION)s</td>
        </tr>
      </table>
    </td>
  </tr>
</table>''' % {'T_CAPTION': skinobj.T_(caption),
               'css': css, 'charset': skinobj.REQUEST['ocw_charset'] })
    r.write('''
<table width="182" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td align="right" background="images/fill_navbutn-background.gif">''')

    for i in in_menu_items:
        if i.has_key('service') and \
           filterobj.is_hidden(i['service']):
            pass
        else:
            menu_item(skinobj, i, filterobj, 0)
        if i.has_key('items'):
            draw_submenu_items = []
            for submenu_item in i['items']:
                if submenu_item.has_key('service') and \
                   filterobj.is_hidden(submenu_item['service']):
                    pass
                else:
                    copy_of_item = copy.copy(submenu_item)
                    draw_submenu_items.append(copy_of_item)
            if len(draw_submenu_items) > 0:
                draw_submenu_items[0]['border_item'] = 1
                if len(draw_submenu_items) == 2:
                    draw_submenu_items[1]['border_item'] = 1
                else:
                    draw_submenu_items[-1]['border_item'] = 2
            for j in draw_submenu_items:
                menu_item(skinobj, j, filterobj, 1)
                
    r.write('''
    </td>
  </tr>
</table>''')
    r.write('''
  <table width="199" height="182" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td valign="top" background="images/nav_footer.gif">
      <table width="199" border="0" cellspacing="0" cellpadding="0" background="images/clear.gif">
        <tr>
          <td height="107">&nbsp;</td>
        </tr>
      </table>
      <table border="0" cellspacing="0" cellpadding="0" background="images/clear.gif">
        <tr>
          <td width="7"><img src="images/clear.gif" width="7" height="1"/></td> 
          <td width="73"><img src="images/logo_ensim.gif" width="73" height="46" border="0"/></td>
          <td width="48"><img src="images/clear.gif" width="40" height="8"/></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table width="189" border="0" cellspacing="0" cellpadding="0" background="images/clear.gif">
  <tr> 
    <td width="10"><img src="images/clear.gif" width="10" height="1"/></td>
    <td width="179">
      <table width="179" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td class="Utxt2">%s %s <BR> %s
</td>
        </tr>
        <tr>
          <td class="Utxt2">&nbsp;</td>
        </tr>
        <tr>
          <td class="Utxt2">&nbsp;</td>
        </tr>
      </table>
    </td>
  </tr>
</table>''' % (skinobj.get_product_name(), skinobj.get_display_version(), skinobj.get_domain_limit()))
    r.write('''
</body>
</html>''')
      

class Skin(skin.SkinBase):
    
    def appliance_navbar(self):
        filterobj = skin.UnhiddenServicesFilter(self.REQUEST)
        dict_to_menu(self, AA_menu_items, filterobj, 'SYSTEM MENU',
                     '/stylesheet/appliance.css')

    def reseller_navbar(self):
        filterobj = skin.UnhiddenServicesFilter(self.REQUEST)
        dict_to_menu(self, RA_menu_items, filterobj, 'SYSTEM MENU',
                     '/stylesheet/reseller.css')
        
    def site_navbar(self):
        filterobj = skin.EnabledServicesFilter(self.REQUEST)
        dict_to_menu(self, SA_menu_items, filterobj, 'SYSTEM MENU',
                     '/stylesheet/site.css')

    def user_navbar(self):
        filterobj = skin.EnabledServicesFilter(self.REQUEST)
        dict_to_menu(self, UA_menu_items, filterobj, 'SYSTEM MENU',
                     '/stylesheet/user.css')

    def user_frame(self):
        r = self.get_response()
        site,user = requestutil.get_site_user_from_request(self.REQUEST)
        uaconf = dashboard.get_user_conf(site,user)
        dashboard.load_user_request(self.REQUEST, uaconf)
        self.load_common_translations(uaconf)

        vars = {'charset': self.REQUEST['ocw_charset']}
        vars.update(uaconf)
        
        a = r.write('''
<HTML>
<HEAD>
<meta http-equiv="content-type" content="text/html; charset=%(charset)s">
<base href="https://%(http_host)s/webhost/services/virtualhosting/useradmin/" />
<!----- Copyright (c) 2000-2003 Ensim Corporation ----->
<TITLE>%(T_User_Administrator)s %(display_version)s (%(login_name)s)</TITLE>
</HEAD>
<frameset rows="79,*,7" cols="*" framespacing="0" frameborder="no" border="0">
  <frame src="topbar" name="top" frameborder="no" scrolling="no" noresize marginwidth="0" marginheight="0" id="top">
  <frameset cols="199,*" framespacing="0" frameborder="no" border="0">
    <frame src="navbar" name="navigation" frameborder="no" scrolling="no" noresize marginwidth="0" marginheight="0" id="navigation">
    <frame src="view_shortcuts" name="main" frameborder="no" scrolling="auto" noresize marginwidth="0" marginheight="0" id="main" >
  </frameset>
  <frame src="footer" name="footer" frameborder="no" scrolling="no" noresize marginwidth="0" marginheight="0" id="footer">
</frameset>
<noframes>
%(frames_warning)s
</noframes>
</HTML>''' % vars)

    def site_frame(self):
        r = self.get_response()
        site = requestutil.get_site_from_request(self.REQUEST)
        saconf = dashboard.get_site_conf(site)
        dashboard.load_site_request(self.REQUEST, saconf)
        self.load_common_translations(saconf)
        vars = {'charset': self.REQUEST['ocw_charset']}
        vars.update(saconf)
        a = r.write('''
<HTML>
<HEAD>
<meta http-equiv="content-type" content="text/html; charset=%(charset)s">
<base href="https://%(http_host)s/webhost/services/virtualhosting/siteadmin/" />
<!----- Copyright (c) 2000-2003 Ensim Corporation ----->
<TITLE>%(T_Site_Administrator)s %(display_version)s (%(login_name)s)</TITLE>
</HEAD>
<frameset rows="79,*,7" cols="*" framespacing="0" frameborder="no" border="0">
  <frame src="topbar" name="top" frameborder="no" scrolling="no" noresize marginwidth="0" marginheight="0" id="top">
  <frameset cols="199,*" framespacing="0" frameborder="no" border="0">
    <frame src="navbar" name="navigation" frameborder="no" scrolling="auto" noresize marginwidth="0" marginheight="0" id="navigation">
    <frame src="view_dashboard" name="main" frameborder="no" scrolling="auto" noresize marginwidth="0" marginheight="0" id="main" >
  </frameset>
  <frame src="footer" name="footer" frameborder="no" scrolling="no" noresize marginwidth="0" marginheight="0" id="footer">
</frameset>
<noframes>
%(frames_warning)s
</noframes>
</HTML>''' % vars)

    def reseller_frame(self):
        r = self.get_response()

        username = requestutil.get_reseller_from_request(self.REQUEST)
        raconf = dashboard.get_reseller_conf(username)
        dashboard.load_reseller_request(self.REQUEST, raconf)
        
        self.load_common_translations(raconf)
        
        vars = {'charset': self.REQUEST['ocw_charset']}
        vars.update(raconf)
        a = r.write('''
<HTML>
<HEAD>
<meta http-equiv="content-type" content="text/html; charset=%(charset)s">
<base href="https://%(http_host)s/webhost/services/reseller/resellercp/" />
<!----- Copyright (c) 2000-2003 Ensim Corporation ----->
<TITLE>%(T_Reseller_Administrator)s %(display_version)s (%(login_name)s)</TITLE>
</HEAD>
<frameset rows="79,*,7" cols="*" framespacing="0" frameborder="no" border="0">
  <frame src="topbar" name="top" frameborder="no" scrolling="no" noresize marginwidth="0" marginheight="0" id="top">
  <frameset cols="199,*" framespacing="0" frameborder="no" border="0">
    <frame src="navbar" name="navigation" frameborder="no" scrolling="no" noresize marginwidth="0" marginheight="0" id="navigation">
    <frame src="view_shortcuts" name="main" frameborder="no" scrolling="auto" noresize marginwidth="0" marginheight="0" id="main" >
  </frameset>
  <frame src="footer" name="footer" frameborder="no" scrolling="no" noresize marginwidth="0" marginheight="0" id="footer">
</frameset>
<noframes>
%(frames_warning)s
</noframes>
</HTML>''' % vars)

       
    def appliance_frame(self):
        r = self.get_response()
        
        aaconf = dashboard.get_appliance_conf()
        dashboard.load_appliance_request(self.REQUEST, aaconf)
        
        self.load_common_translations(aaconf)
        vars = {'charset': self.REQUEST['ocw_charset']}
        vars.update(aaconf)
        a = r.write('''
<HTML>
<HEAD>
<base href="https://%(http_host)s/webhost/" />
<!----- Copyright (c) 2000-2003 Ensim Corporation ----->
<TITLE>%(T_Appliance_Administrator)s %(display_version)s (%(login_name)s)</TITLE>
</HEAD>
<frameset rows="79,*,7" cols="*" framespacing="0" frameborder="no" border="0">
  <frame src="topbar" name="top" frameborder="no" scrolling="no" noresize marginwidth="0" marginheight="0" id="top">
  <frameset cols="199,*" framespacing="0" frameborder="no" border="0">
    <frame src="navbar" name="navigation" frameborder="no" scrolling="no" noresize marginwidth="0" marginheight="0" id="navigation">
    <frame src="view_shortcuts" name="main" frameborder="no" scrolling="auto" noresize marginwidth="0" marginheight="0" id="main" >
  </frameset>
  <frame src="footer" name="footer" frameborder="no" scrolling="no" noresize marginwidth="0" marginheight="0" id="footer">
</frameset>
<noframes>
%(frames_warning)s
</noframes>
</HTML>''' % vars)

    def statcell_draw(self, percent):
        if percent > 1.0:
            percent = 1.0
        return '<nobr>%s%s</nobr>' % \
          (string.join(['<img src="images/statcell_on.gif" width="4" height="10"/>'] * int(percent * 37), ''),
           string.join(['<img src="images/statcell_off.gif" width="4" height="10"/>'] * int((1.0 - percent) * 37), ''))

    def user_top(self):
        site,user = requestutil.get_site_user_from_request(self.REQUEST)
        uaconf = dashboard.get_user_conf(site,user)
        self.load_common_translations(uaconf)
        r = self.get_response()
        vars = {'charset': self.REQUEST['ocw_charset']}
        vars.update(uaconf)
        r.write('''
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=%(charset)s">
<link href="/stylesheet/user.css" rel="stylesheet" type="text/css">
</head>
<body background="images/fill_body-background.gif" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr>
      <td width="100%%" bgcolor="#E8E8E8"><img src="images/clear.gif" width="1" height="6"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td><img src="images/clear.gif" width="1" height="5"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="4" valign="top"><img src="images/clear.gif" width="4" height="1"/></td>
    <td width="192" valign="top" background="images/hdr_logo.gif">
      <table width="192" height="60" border="0" cellspacing="0" cellpadding="0" background="images/clear.gif">
      <tr>
        <td align="center"><img src="/webhost/services/virtualhosting/useradmin/reseller_logo"/></td>
      </tr>
      </table>
    </td>
    <td width="506" valign="top">
      <table width="228" height="17" border="0" cellspacing="0" cellpadding="0">
      <tr>
        <td background="images/hdr_serverstats.gif" class="Utxt1Bold">&nbsp;&raquo;%(T_User_Administrator)s</td>
      </tr>
      </table>
      <table width="228" height="42" border="0" cellspacing="0" cellpadding="0">
      <tr>
        <td align="center" valign="top" background="images/hdr_serverstats-bg.gif">
          <table width="226" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td><img src="images/clear.gif" width="1" height="2"/></td>
          </tr>
          </table>
          <table width="218" border="0" cellspacing="0" cellpadding="0">
            <tr>
              <td class="Utxt2"><span class="Utxt2Bold">%(T_Domain_Name)s:</span> %(siteinfo_domain)s</td>
            </tr>
            <tr>
              <td class="Utxt2"><span class="Utxt2Bold">%(T_Username)s:</span> %(username)s</td>
            </tr>
          </table>
        </td>
      </tr>
      </table>

      <table width="228" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td bgcolor="#DCDCDC"><img src="images/clear.gif" width="1" height="1"/></td>
        </tr>
      </table>
    </td>
    <td width="100%%" valign="top"><img src="images/clear.gif" width="25" height="1"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td><img src="images/clear.gif" width="1" height="3"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="165" background="images/fill_hdr-divline.gif"><img src="images/clear.gif" width="1" height="4"/></td>
    <td width="60"><img src="images/hdr_divline-topcut.gif" width="60" height="4"/></td>
    <td background="images/fill_hdr-divline.gif"><img src="images/clear.gif" width="1" height="4"/></td>
  </tr>
</table>
</body>
</html>''' %  vars)

              
    def site_top(self):
        site = requestutil.get_site_from_request(self.REQUEST)
        conf = dashboard.get_site_conf(site)
        siteconf = {'web_server_name': conf['apache']['webserver'],
                    'ftp_server_name': conf['proftpd']['ftpserver'],
                    'mail_server_name': conf['sendmail']['mailserver'],
                    'login_name': conf['siteinfo']['admin_user'],}
        siteconf.update(get_misc_site_data(conf))
        self.load_common_translations(siteconf)
        r = self.get_response()
        vars = {'charset': self.REQUEST['ocw_charset']}
        vars.update(siteconf)
        r.write('''
  <html>
<head>
<meta http-equiv="content-type" content="text/html; charset=%(charset)s">
<link href="/stylesheet/site.css" rel="stylesheet" type="text/css">
</head>

<body background="images/fill_body-background.gif" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="100%%" bgcolor="#E8E8E8"><img src="images/clear.gif" width="1" height="6"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td><img src="images/clear.gif" width="1" height="5"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="4" valign="top"><img src="images/clear.gif" width="4" height="1"/></td>
    <td width="192" valign="top" background="images/hdr_logo.gif">
      <table width="192" height="60" border="0" cellspacing="0" cellpadding="0" background="images/clear.gif">
        <tr>
          <td align="center"><img src="/webhost/services/virtualhosting/siteadmin/reseller_logo"/></td>
        </tr>
      </table>
    </td>
    <td width="275" valign="top">
      <table width="275" height="17" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td background="images/hdr_siteadmin.gif" class="Utxt1Bold">&nbsp;&raquo;%(T_Site_Administrator)s</td>
        </tr>
      </table>
      <table width="275" height="42" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td valign="top" background="images/hdr_siteadmin-bg.gif" align="center">
            <table width="265" border="0" cellpadding="0" cellspacing="0" background="images/clear.gif">
              <tr>
                <td class="Utxt2"><span class="Utxt2Bold">%(T_Web_Server_Name)s:</span> %(web_server_name)s</td>
              </tr>
              <tr>
                <td class="Utxt2"><span class="Utxt2Bold">%(T_Mail_Server_Name)s:</span> %(mail_server_name)s</td>
              </tr>
              <tr>
                <td class="Utxt2"><span class="Utxt2Bold">%(T_FTP_Server_Name)s:</span> %(ftp_server_name)s</td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
      <table width="275" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td bgcolor="#DCDCDC"><img src="images/clear.gif" width="1" height="1"/></td>
        </tr>
      </table>
    </td>
    <td width="228" valign="top">
      <table width="228" height="17" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td background="images/hdr_serverstats.gif" class="Utxt1Bold">&nbsp;&raquo;%(T_Site_Details)s</td>
        </tr>
      </table>
      <table width="228" height="42" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td align="center" valign="top" background="images/hdr_serverstats-bg.gif">
            <table width="226" border="0" cellspacing="0" cellpadding="0">
              <tr>
                <td><img src="images/clear.gif" width="1" height="2"/></td>
              </tr>
            </table>
            <table width="218" border="0" cellspacing="0" cellpadding="0">
              <tr>
                <td class="Utxt2"><span class="Utxt2Bold">%(T_IP_Address)s:</span> %(ip_addr)s</td>
              </tr>
              <tr>
                <td class="Utxt2"><span class="Utxt2Bold">%(T_Administrator)s:</span> 
				  %(login_name)s</td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
      <table width="228" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td bgcolor="#DCDCDC"><img src="images/clear.gif" width="1" height="1"/></td>
        </tr>
      </table>
    </td>
    <td width="100%%" valign="top"><img src="images/clear.gif" width="25" height="1"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td><img src="images/clear.gif" width="1" height="3"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="165" background="images/fill_hdr-divline.gif"><img src="images/clear.gif" width="1" height="4"/></td>
    <td width="60"><img src="images/hdr_divline-topcut.gif" width="60" height="4"/></td>
    <td background="images/fill_hdr-divline.gif"><img src="images/clear.gif" width="1" height="4"/></td>
  </tr>
</table>
</body>
</html>''' % vars)
      
    def appliance_top(self):
        r = self.get_response()
        aaconf = dashboard.get_appliance_conf()
        aaconf.update(dashboard.get_appliance_usage())
        self.load_common_translations(aaconf)
        aaconf['uptime'] = self.T_duration(aaconf['uptime'])
        aaconf['statcell'] = self.statcell_draw(float(aaconf['disk_used']) / \
                                                float(aaconf['disk_total']))
        self.batch_ftoa(aaconf, ['disk_used', 'disk_total'])

        vars = {'charset': self.REQUEST['ocw_charset']}
        vars.update(aaconf)
        r.write('''
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=%(charset)s">
<link href="/stylesheet/appliance.css" rel="stylesheet" type="text/css">
</head>

<body background="images/fill_body-background.gif" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="100%%" bgcolor="#E8E8E8"><img src="images/clear.gif" width="1" height="6"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td><img src="images/clear.gif" width="1" height="5"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="4" valign="top"><img src="images/clear.gif" width="4" height="1"/></td>
    <td width="192" valign="top" background="images/hdr_logo.gif">
      <table width="192" height="60" border="0" cellspacing="0" cellpadding="0" background="images/clear.gif">
        <tr>
          <td align="center"><img src="/webhost/logo_icon"/></td>

        </tr>
      </table>
    </td>
    <td width="275" valign="top">
      <table width="275" height="17" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td background="images/hdr_siteadmin.gif" class="Utxt1Bold">&nbsp;&raquo;%(T_Appliance_Administrator)s</td>
        </tr>

      </table>
      <table width="275" height="42" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td valign="top" background="images/hdr_siteadmin-bg.gif" align="center">
            <table width="265" border="0" cellpadding="0" cellspacing="0" background="images/clear.gif">
              <tr>
                <td class="Utxt2"><span class="Utxt2Bold">%(T_Server)s:</span> %(server_name)s</td>

              </tr>
              <tr>
                <td class="Utxt2"><span class="Utxt2Bold">%(T_IP_Address)s:</span> %(server_ip)s</td>
              </tr>
              <tr>
                <td class="Utxt2"><span class="Utxt2Bold">%(T_Domain_Count)s:</span> %(domain_count)d</td>

              </tr>
            </table>
          </td>
        </tr>
      </table>
      <table width="275" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td bgcolor="#DCDCDC"><img src="images/clear.gif" width="1" height="1"/></td>
        </tr>

      </table>
    </td>
    <td width="228" valign="top">
      <table width="228" height="17" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td background="images/hdr_serverstats.gif" class="Utxt1Bold">&nbsp;&raquo;%(T_Server_Statistics)s</td>
        </tr>
      </table>

      <table width="228" height="42" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td align="center" valign="top" background="images/hdr_serverstats-bg.gif">
            <table width="226" border="0" cellspacing="0" cellpadding="0">
              <tr>
                <td><img src="images/clear.gif" width="1" height="2"/></td>
              </tr>
            </table>
            <table width="226" height="16" border="0" cellspacing="0" cellpadding="0">
              <tr>
                <td background="images/statcell_module.gif">
                  <table width="226" border="0" cellpadding="0" cellspacing="0" background="images/clear.gif">
                    <tr> 
                      <td width="68"><img src="images/clear.gif" width="1" height="1"/></td>
                      <td width="158">%(statcell)s</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
            <table width="218" border="0" cellspacing="0" cellpadding="0">
              <tr>
                <td align="right" class="Utxt2">%(disk_used)s / %(disk_total)s %(T_MB_Used)s</td>
              </tr>
              <tr> 
                <td align="right" class="Utxt2">%(uptime)s</td>

              </tr>
            </table>
          </td>
        </tr>
      </table>
      <table width="228" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td bgcolor="#DCDCDC"><img src="images/clear.gif" width="1" height="1"/></td>
        </tr>

      </table>
    </td>
    <td width="17" valign="top"><img src="images/clear.gif" width="17" height="1"/></td>
    <td width="100%%" valign="top"><img src="images/clear.gif" width="25" height="1"/></td>
    <td width="4" valign="top"><img src="images/hdrgfx_2.gif" width="4" height="49"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td><img src="images/clear.gif" width="1" height="3"/></td>

  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="165" background="images/fill_hdr-divline.gif"><img src="images/clear.gif" width="1" height="4"/></td>
    <td width="60"><img src="images/hdr_divline-topcut.gif" width="60" height="4"/></td>
    <td background="images/fill_hdr-divline.gif"><img src="images/clear.gif" width="1" height="4"/></td>
  </tr>
</table>
</body>
</html>''' % vars)

    def reseller_top(self):
        lang = requestutil.lang_from_request(self.REQUEST)
        r = self.get_response()
        username = requestutil.get_reseller_from_request(self.REQUEST)
        raconf = dashboard.get_reseller_conf(username)
        raconf.update(dashboard.get_reseller_usage(username))
        self.load_common_translations(raconf)
        try:
            raconf['statcell'] = self.statcell_draw(float(raconf['diskquota_used']) / \
                                                float(raconf['diskquota_total']))
        except:
            raconf['statcell'] = self.T_('N/A')

        self.batch_ftoa(raconf, ['diskquota_used', 'diskquota_total'])
        raconf['uptime'] = self.T_duration(raconf['uptime'])

        vars = {'charset': self.REQUEST['ocw_charset']}
        vars.update(raconf)

        r.write('''
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=%(charset)s">
<link href="/stylesheet/reseller.css" rel="stylesheet" type="text/css">
</head>

<body background="images/fill_body-background.gif" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="100%%" bgcolor="#E8E8E8"><img src="images/clear.gif" width="1" height="6"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td><img src="images/clear.gif" width="1" height="5"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="4" valign="top"><img src="images/clear.gif" width="4" height="1"/></td>
    <td width="192" valign="top" background="images/hdr_logo.gif">
      <table width="192" height="60" border="0" cellspacing="0" cellpadding="0" background="images/clear.gif">
        <tr>
          <td align="center"><img src="/webhost/services/reseller/resellercp/reseller_logo"/></td>
        </tr>
      </table>
    </td>
    <td width="275" valign="top">
      <table width="275" height="17" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td background="images/hdr_siteadmin.gif" class="Utxt1Bold">&nbsp;&raquo;%(T_Reseller_Administrator)s</td>
        </tr>
      </table>
      <table width="275" height="42" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td valign="top" background="images/hdr_siteadmin-bg.gif" align="center">
            <table width="265" border="0" cellpadding="0" cellspacing="0" background="images/clear.gif">
              <tr>
                <td class="Utxt2"><span class="Utxt2Bold">%(T_Username)s:</span> %(username)s </td>
              </tr>
              <tr>
                <td class="Utxt2"><span class="Utxt2Bold">%(T_Server)s:</span> %(server_name)s </td>
              </tr>
              <tr>
                <td class="Utxt2"><span class="Utxt2Bold">%(T_IP_Address)s:</span> %(server_ip)s</td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
      <table width="275" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td bgcolor="#DCDCDC"><img src="images/clear.gif" width="1" height="1"/></td>
        </tr>
      </table>
    </td>
    <td width="228" valign="top">
      <table width="228" height="17" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td background="images/hdr_serverstats.gif" class="Utxt1Bold">&nbsp;&raquo;%(T_Reseller_Statistics)s</td>
        </tr>
      </table>
      <table width="228" height="42" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td align="center" valign="top" background="images/hdr_serverstats-bg.gif">
            <table width="226" border="0" cellspacing="0" cellpadding="0">
              <tr>
                <td><img src="images/clear.gif" width="1" height="2"/></td>
              </tr>
            </table>
            <table width="226" height="16" border="0" cellspacing="0" cellpadding="0">
              <tr>
                <td background="images/statcell_module.gif">
                  <table width="226" border="0" cellpadding="0" cellspacing="0" background="images/clear.gif">
                    <tr> 
                      <td width="68"><img src="images/clear.gif" width="1" height="1"/></td>
                      <td width="158">%(statcell)s</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
            <table width="218" border="0" cellspacing="0" cellpadding="0">
              <tr>
                <td align="right" class="Utxt2">%(diskquota_used)s / %(diskquota_total)s %(T_MB_Used)s</td>
              </tr>
              <tr> 
                <td align="right" class="Utxt2">%(uptime)s</td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
      <table width="228" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td bgcolor="#DCDCDC"><img src="images/clear.gif" width="1" height="1"/></td>
        </tr>
      </table>
    </td>
    <td width="100%%" valign="top"><img src="images/clear.gif" width="25" height="1"/></td>
    <td width="4" valign="top"><img src="images/hdrgfx_2.gif" width="4" height="49"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td><img src="images/clear.gif" width="1" height="3"/></td>
  </tr>
</table>
<table width="100%%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="165" background="images/fill_hdr-divline.gif"><img src="images/clear.gif" width="1" height="4"/></td>
    <td width="60"><img src="images/hdr_divline-topcut.gif" width="60" height="4"/></td>
    <td background="images/fill_hdr-divline.gif"><img src="images/clear.gif" width="1" height="4"/></td>
  </tr>
</table>
</body>

</html>''' % vars)

    def shortcut_cell(self, cell, filterobj):
        r = self.get_response()
        caption = self.T_(cell['caption'])
        r.write('''
                                  <td width="60" valign="top"><img src="%s" width="51" height="51"/></td>

                                  <td width="132" valign="top">
                                    <table border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td colspan="2" class="Utxt1Bold">%s</td>
                                      </tr>''' % (cell['icon'], caption))
        for i in cell['items']:
            text,href = self.T_(i[0]), i[1]
            if len(i) == 3 and filterobj.is_hidden(i[2]):
                pass
            else:
                r.write('''
                                      <tr>
                                        <td width="7"><img src="images/bullet1.gif" width="7" height="3"/></td>
                                        <td class="Utxt2"><a href="%s">%s</a></td>

                                      </tr>''' % \
                    (href, text))
        r.write('''
                                    </table>
                                  </td>''')
    def shortcut_row(self, idx, tbl, filterobj):
        r = self.get_response()
        r.write('''
            <table width="528" border="0" cellspacing="0" cellpadding="1">
              <tr>
                <td bgcolor="#CFCFCF">
                  <table width="526" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td bgcolor="#E6E6E6">
                        <table width="522" border="0" cellspacing="0" cellpadding="5">
                          <tr>
                            <td background="images/fill_system-modules.gif">
                              <table width="512" border="0" cellpadding="0" cellspacing="0" background="images/clear.gif">
                                <tr>''')
        if idx < (len(tbl) - tbl_width):
            lastrow = 0
        else:
            lastrow = 1
        for cell in tbl[idx:idx+tbl_width]:
            self.shortcut_cell(cell, filterobj)
        if lastrow and len(tbl) % tbl_width > 0:
            for i in range(0, tbl_width - (len(tbl) % tbl_width)):
                self.shortcut_cell(blank_cell, filterobj)
        r.write('''
                                </tr>
                              </table>
                            </td>
                          </tr>
                        </table>
                      </td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>''')
        if not lastrow:
            r.write('''
            <table width="528" border="0" cellspacing="0" cellpadding="0">
              <tr>
                <td><img src="images/clear.gif" width="1" height="8"/></td>
              </tr>
            </table>''')

    def reseller_system_stats(self, raconf):
        r = self.get_response()
        try:
            raconf['diskquota_statcell'] = self.statcell_draw(float(raconf['diskquota_used']) / \
                                                          float(raconf['diskquota_total']))
        except:
            raconf['diskquota_statcell'] = self.T_('N/A')
            
        try:
            raconf['bandwidth_statcell'] = self.statcell_draw(float(raconf['bandwidth_used']) / \
                                                      float(raconf['bandwidth_total']))
        except:
            raconf['bandwidth_statcell'] = self.T_('N/A')
                                                          
        self.load_common_translations(raconf)

        self.batch_ftoa(raconf, ['bandwidth_used', 'bandwidth_total',
                                 'diskquota_used', 'diskquota_total'])

        r.write('''
      <table width="538" height="22" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td background="images/modhdr_bg-orange.gif" valign="top">
            <table width="538" border="0" cellpadding="2" cellspacing="0" background="images/clear.gif">
              <tr>
                <td width="7"><img src="images/clear.gif" width="1" height="1"/></td>
                <td width="531" class="Utxt3Bold">%(T_SYSTEM_STATS)s<img src="images/bullet2.gif" width="14" height="5"/></td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td align="center" bgcolor="#E6E6E6">
            <table width="528" border="0" cellspacing="0" cellpadding="1">
              <tr>
                <td bgcolor="#CFCFCF">
                  <table width="526" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td bgcolor="#E6E6E6">
                        <table width="522" border="0" cellspacing="0" cellpadding="5">
                          <tr>
                            <td background="images/fill_system-modules.gif">
                              <table width="512" border="0" cellpadding="0" cellspacing="0" background="images/clear.gif">
                                <tr>
                                  <td width="245" valign="top">
                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td class="Utxt1Bold" width="100%%">%(T_Disk_Space)s</td>
                                        <td class="statBdr" bgcolor="#ECECEC"><table border="0" cellspacing="0" cellpadding="1"><tr><td>%(diskquota_statcell)s</td></tr></table></td>
                                      </tr>
                                      <tr>
                                        <td colspan="2" align="right" class="Utxt2">%(diskquota_used)s / %(diskquota_total)s %(T_MB_Used)s</td>
                                      </tr>
                                    </table>
                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td><img src="images/clear.gif" width="1" height="6"/></td>
                                      </tr>
                                    </table>
                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td class="Utxt1Bold" width="100%%">%(T_Bandwidth)s</td>
                                        <td class="statBdr" bgcolor="#ECECEC"><table border="0" cellspacing="0" cellpadding="1"><tr><td>%(bandwidth_statcell)s</td></tr></table></td>
                                      </tr>
                                      <tr>
                                        <td colspan="2" align="right" class="Utxt2">%(bandwidth_used)s / %(bandwidth_total)s %(T_MB_Used)s</td>
                                      </tr>
                                    </table>
                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td><img src="images/clear.gif" width="1" height="6"/></td>
                                      </tr>
                                    </table>
                                  </td>
                                  <td width="22"><img src="images/clear.gif" width="22" height="8"/></td>
                                  <td width="245" valign="top">
                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td class="Utxt1Bold">%(T_Fullname)s</td>
                                        <td width="130" align="right" class="Utxt2">%(reseller_fullname)s</td>
                                      </tr>
                                      <tr>
                                        <td class="Utxt1Bold">%(T_Email)s</td> 
                                        <td width="130" align="right" class="Utxt2">%(reseller_email)s</td>
                                      </tr>
                                    </table>
                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td><img src="images/clear.gif" width="1" height="6"/></td>
                                      </tr>
                                    </table>
                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td class="Utxt1Bold">%(T_Users)s </td>
                                        <td width="130" align="right" class="Utxt2">%(users_used)s / %(users_total)s</td>
                                      </tr>
                                      <tr>
                                        <td class="Utxt1Bold">%(T_IP_Based_Domains)s </td> 
                                        <td width="130" align="right" class="Utxt2">%(ipinfo_ip_used)s / %(ipinfo_ip_total)s</td>
                                      </tr>
                                      <tr>
                                        <td class="Utxt1Bold">%(T_Name_Based_Domains)s </td> 
                                        <td width="130" align="right" class="Utxt2">%(ipinfo_nb_used)s / %(ipinfo_nb_total)s</td>
                                      </tr>
                                    </table>
                                  </td>
                                </tr>
                              </table>
                            </td>
                          </tr>
                        </table>
                      </td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>''' % raconf)
        r.write('''
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td bgcolor="#E6E6E6"><img src="images/clear.gif" width="1" height="11"/></td>
        </tr>
      </table>
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td width="17"><img src="images/modftr_start.gif" width="17" height="17"/></td>
          <td width="100%" align="right" bgcolor="#D3D3D3" class="Utxt2">&nbsp;</td>
          <td width="21"><img src="images/modftr_end.gif" width="21" height="17"/></td>
        </tr>
      </table>
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td><img src="images/clear.gif" width="1" height="10"/></td>
        </tr>
      </table>''')
        
    def site_system_stats(self, saconf, filterobj):
        r = self.get_response()
        lang = requestutil.lang_from_request(self.REQUEST)
        #Check basic or pro version.  
        webppliance_type = egv.is_basic() # PRO = 0, BASIC = 1
        try:
            saconf['diskquota_statcell'] = self.statcell_draw(float(saconf['diskquota_used']) / \
                                                              float(saconf['diskquota_total']))
        except:
            saconf['diskquota_statcell'] = self.T_('N/A')
        try:
            saconf['bandwidth_statcell'] = self.statcell_draw(float(saconf['bandwidth_used']) / \
                                                              float(saconf['bandwidth_total']))
        except:
            saconf['bandwidth_statcell'] = self.T_('N/A')

        if not saconf.has_key('diskquota_used'):
            saconf['diskquota_used'] = self.T_('N/A')
        else:
            saconf['diskquota_used'] = self.ftoa(saconf['diskquota_used'])
        if not saconf.has_key('diskquota_total'):
            saconf['diskquota_total'] = self.T_('N/A')
        else:
            saconf['diskquota_total'] = self.ftoa(saconf['diskquota_total'])

        if not saconf.has_key('bandwidth_used'):
            saconf['bandwidth_used'] = self.T_('N/A')
        else:
            saconf['bandwidth_used'] = self.ftoa(saconf['bandwidth_used'])
        saconf['bandwidth_total'] = self.ftoa(saconf['bandwidth_total'])

        r.write('''
      <table width="538" height="22" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td background="images/modhdr_bg-purp.gif" valign="top">
            <table width="538" border="0" cellpadding="2" cellspacing="0" background="images/clear.gif">
              <tr>
                <td width="7"><img src="images/clear.gif" width="1" height="1"/></td>
                <td width="531" class="Utxt3Bold">%(T_SYSTEM_STATS)s<img src="images/bullet2.gif" width="14" height="5"/></td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td align="center" bgcolor="#E6E6E6">
            <table width="528" border="0" cellspacing="0" cellpadding="1">
              <tr>
                <td bgcolor="#CFCFCF">
                  <table width="526" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td bgcolor="#E6E6E6">
                        <table width="522" border="0" cellspacing="0" cellpadding="5">
                          <tr>
                            <td background="images/fill_system-modules.gif">
                              <table width="512" border="0" cellpadding="0" cellspacing="0" background="images/clear.gif">
                                <tr>
                                  <td width="245" valign="top">
                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td class="Utxt1Bold" width="100%%">%(T_Disk_Space)s</td>
                                        <td class="statBdr" bgcolor="#ECECEC"><table border="0" cellspacing="0" cellpadding="1"><tr><td>%(diskquota_statcell)s</td></tr></table></td>
                                      </tr>
                                      <tr>
                                        <td colspan="2" align="right" class="Utxt2">%(diskquota_used)s / %(diskquota_total)s %(T_MB_Used)s</td>
                                      </tr>
                                    </table>
                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td><img src="images/clear.gif" width="1" height="6"/></td>
                                      </tr>
                                    </table> ''' %saconf)

        # For BASIC bandwidth is hidden
        if not filterobj.is_hidden('bandwidth') and not webppliance_type:  
            r.write('''
                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td class="Utxt1Bold" width="100%%">%(T_Bandwidth)s</td>
                                        <td class="statBdr" bgcolor="#ECECEC"><table border="0" cellspacing="0" cellpadding="1"><tr><td>%(bandwidth_statcell)s</td></tr></table></td>
                                      </tr>
                                      <tr>
                                        <td colspan="2" align="right" class="Utxt2">%(bandwidth_used)s / %(bandwidth_total)s %(T_MB_Used)s</td>
                                      </tr>
                                    </table>''' % saconf)
        r.write('''

                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td><img src="images/clear.gif" width="1" height="6"/></td>
                                      </tr>
                                    </table>
                                  </td>
                                  <td width="22"><img src="images/clear.gif" width="22" height="8"/></td>
                                  <td width="245" valign="top">
                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td class="Utxt1Bold">%(T_Users)s </td>
                                        <td width="130" align="right" class="Utxt2">%(users_used)s / %(users_total)s</td>
                                      </tr>
                                      <tr>
                                        <td class="Utxt1Bold">%(T_Databases)s </td> 
                                        <td width="130" align="right" class="Utxt2">%(mysql_used)s / %(mysql_total)s</td>
                                      </tr>
                                      <tr>
                                        <td class="Utxt1Bold">%(T_Subdomains)s </td> 
                                        <td width="130" align="right" class="Utxt2">%(subdomain_used)s / %(subdomain_total)s</td>
                                      </tr>
                                    </table>
                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td><img src="images/clear.gif" width="1" height="6"/></td>
                                      </tr>
                                    </table>
                                    <table width="245" border="0" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td class="Utxt1Bold">%(T_Web_Document_Path)s</td>
                                      </tr>
                                      <tr>
                                        <td class="Utxt2">%(apache_htmlpath)s</td>
                                      </tr>
                                      <tr>
                                        <td class="Utxt1Bold">%(T_CGI_Document_Path)s</td>
                                      </tr>
                                      <tr>
                                        <td class="Utxt2">%(apache_cgipath)s</td>
                                      </tr>
                                    </table>
                                  </td>
                                </tr>
                              </table>
                            </td>
                          </tr>
                        </table>
                      </td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>''' % saconf)
        r.write('''
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td bgcolor="#E6E6E6"><img src="images/clear.gif" width="1" height="11"/></td>
        </tr>
      </table>
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td width="17"><img src="images/modftr_start.gif" width="17" height="17"/></td>
          <td width="100%" align="right" bgcolor="#D3D3D3" class="Utxt2">&nbsp;</td>
          <td width="21"><img src="images/modftr_end.gif" width="21" height="17"/></td>
        </tr>
      </table>
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td><img src="images/clear.gif" width="1" height="10"/></td>
        </tr>
      </table>''')
        
    def asp_table(self, tbl, filterobj, titlebar_img):
        r = self.get_response()
        site = requestutil.get_site_from_request(self.REQUEST)
        if filterobj.is_hidden('aspmgr'):
            return
        aspmgrmod = dashboard.vh3.modules.aspmgr
        lang = self.get_lang()
        all_asps,errs = aspmgrmod.get_all_asps()
        asp_captions = aspmgrmod.list_to_dict(all_asps, 'asp_id')
        asplist,errs = aspmgrmod.get_site_asps(site)
        if len(asplist) == 0:
            return
        
        r.write('''
      <table width="538" height="22" border="0" cellspacing="0" cellpadding="0">

        <tr>
          <td background="%s" valign="top">
            <table width="538" border="0" cellpadding="2" cellspacing="0" background="images/clear.gif">
              <tr>
                <td width="7"><img src="images/clear.gif" width="1" height="1"/></td>
                <td width="531" class="Utxt3Bold">%s<img src="images/bullet2.gif" width="14" height="5"/></td>
              </tr>
            </table>

          </td>
        </tr>
      </table>
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td align="center" bgcolor="#E6E6E6">
            <table>''' % (titlebar_img,
                                                      self.T_('IGNITE')))

        for i in asplist:
            asp = i['asp_id']
            addhtml,managehtml = '',''
            if i['%s_add' % asp] == '1':
                addhtml = aspmgrmod.get_asp_get(site, aspmgrmod.get_epid(),
                                                i['asp_id'], lang,
                                                aspmgrmod.ADDPG,
                                                self.T_('Add'))
            if i['%s_manage' % asp] == '1':
                managehtml = aspmgrmod.get_asp_get(site, aspmgrmod.get_epid(),
                                                   i['asp_id'], lang,
                                                   aspmgrmod.MANAGEPG,
                                                   self.T_('Manage'))
            if addhtml == '' and managehtml == '':
                pass
            else:
                r.write('''
              <tr>
              <td width="7">
                <img src="images/bullet1.gif" width ="7" height="3"/>
              </td>
              <td width="150" valign="middle" class="Utxt2">
                %s
              </td>
              <td class="Utxt2" width="100">
                %s
              </td>
              <td class="Utxt2">
                %s
              </td>
              </tr>''' % \
                        (asp_captions[i['asp_id']]['caption'], addhtml, managehtml))
        r.write('''
            </table>
          </td>
        </tr>
      </table>
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td bgcolor="#E6E6E6"><img src="images/clear.gif" width="1" height="11"/></td>
        </tr>
      </table>
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>

          <td width="17"><img src="images/modftr_start.gif" width="17" height="17"/></td>
          <td width="100%" align="right" bgcolor="#D3D3D3" class="Utxt2">&nbsp;</td>
          <td width="21"><img src="images/modftr_end.gif" width="21" height="17"/></td>
        </tr>
      </table>''')
        r.write('''
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td><img src="images/clear.gif" width="1" height="10"/></td>
        </tr>
      </table>''')
        
    def shortcut_table(self, tbl, filterobj, titlebar_img):
        r = self.get_response()

        r.write('''
      <table width="538" height="22" border="0" cellspacing="0" cellpadding="0">

        <tr>
          <td background="%s" valign="top">
            <table width="538" border="0" cellpadding="2" cellspacing="0" background="images/clear.gif">
              <tr>
                <td width="7"><img src="images/clear.gif" width="1" height="1"/></td>
                <td width="531" class="Utxt3Bold">%s<img src="images/bullet2.gif" width="14" height="5"/></td>
              </tr>
            </table>

          </td>
        </tr>
      </table>
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td align="center" bgcolor="#E6E6E6">''' % (titlebar_img,
                                                      self.T_('HOME')))
        idx = 0
        while idx < len(tbl):
            self.shortcut_row(idx, tbl, filterobj)
            idx = idx + tbl_width
        r.write('''
          </td>
        </tr>
      </table>
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td bgcolor="#E6E6E6"><img src="images/clear.gif" width="1" height="11"/></td>
        </tr>
      </table>
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>

          <td width="17"><img src="images/modftr_start.gif" width="17" height="17"/></td>
          <td width="100%" align="right" bgcolor="#D3D3D3" class="Utxt2">&nbsp;</td>
          <td width="21"><img src="images/modftr_end.gif" width="21" height="17"/></td>
        </tr>
      </table>
    </td>''')

    def shortcut_header(self, css, splash=''):
        r = self.get_response()
        r.write('''
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=%s">
<link href="%s" rel="stylesheet" type="text/css">
</head>

<body background="images/fill_body-background.gif" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" %s>''' % (self.REQUEST['ocw_charset'], css, splash,))
        r.write('''
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="11" valign="top"><img src="images/body_corner1.gif" width="11" height="22"/></td>
    <td width="100%">
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>

          <td><img src="images/body_corner2.gif" width="9" height="3"/></td>
        </tr>
      </table>
      <table width="538" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td><img src="images/clear.gif" width="1" height="9"/></td>
        </tr>
      </table>''')

    def shortcut_footer(self):
        r = self.get_response()
        r.write('''
  </tr>
</table>''')
        r.write('''
</body>
</html>''')

        
    def user_shortcuts(self):
        newtbl = []
        filterobj = skin.EnabledServicesFilter(self.REQUEST)
        r = self.get_response()
        for i in UA_shortcuts:
            if i.has_key('service') and filterobj.is_hidden(i['service']):
                pass
            else:
                # PR 29686 - Spam Filter shows in UserAdmin even if it is not enabled for the
                # site. Proceeding further causes tracebacks. So do not show
                # Spam Filtering Link if it is not enabled for the site. Remove
                # from the Display
                items_copy= copy.deepcopy(i)
                if items_copy['items']:
                    for my_dependent_ser in items_copy['items']:
                        if len(my_dependent_ser) == 3 and my_dependent_ser[2]=='spam_filter':
                            if filterobj.is_hidden(my_dependent_ser[2]):
                                items_copy['items'].remove(my_dependent_ser)
                newtbl.append(items_copy)

        self.shortcut_header('/stylesheet/user.css')
        self.shortcut_table(newtbl, filterobj, 'images/modhdr_bg-green.gif')
        self.shortcut_footer()

    def appliance_shortcuts(self):
        newtbl = []
        filterobj = skin.UnhiddenServicesFilter(self.REQUEST)
        r = self.get_response()
        #Webppliance Type Check
        if egv.is_pro():
            aa_shortcuts = AA_shortcuts
        else:
            aa_shortcuts = AA_shortcuts_basic
        for i in aa_shortcuts:
            if i.has_key('service') and filterobj.is_hidden(i['service']):
                pass
            else:
                new_item = copy.deepcopy(i)
                if i['caption'] == 'CONFIGURATION' and egv.get_manage_type() == 'Standalone':
                    new_item['items'].append(('License',
                                              '/webhost/appliance/view_license'))
                newtbl.append(new_item)
        splash = ''
        if egv.is_basic(): 
            self.get_firstpage_status(self.REQUEST)
            if self.REQUEST.has_key('showpage') and int(self.REQUEST['showpage']) == 1:
                splash = '''onload="javascript:window.open('new_appliance_form','helpWindow','resizable=no,scrollbars=no,height=275,width=400').focus();"'''

        self.shortcut_header('/stylesheet/appliance.css', splash)
        self.shortcut_table(newtbl, filterobj, 'images/modhdr_bg.gif')
        self.shortcut_footer()

    def reseller_shortcuts(self):
        newtbl = []
        filterobj = skin.UnhiddenServicesFilter(self.REQUEST)
        username = requestutil.get_reseller_from_request(self.REQUEST)
        raconf = dashboard.get_reseller_conf(username)
        raconf.update(dashboard.get_reseller_usage(username))
        r = self.get_response()
        for i in RA_shortcuts:
            if i.has_key('service') and filterobj.is_hidden(i['service']):
                pass
            else:
                newtbl.append(i)
        self.shortcut_header('/stylesheet/reseller.css')
        self.reseller_system_stats(raconf)
        self.shortcut_table(newtbl, filterobj, 'images/modhdr_bg-orange.gif')
        self.shortcut_footer()

    def get_stylesheet_path(self):
        return os.path.join(self.skin_base_dir, 'css', 'global.css')

    def site_shortcuts(self):
        newtbl = []
        filterobj = skin.EnabledServicesFilter(self.REQUEST)
        site = requestutil.get_site_from_request(self.REQUEST)

        siteconf = dashboard.get_site_conf(site)
        usageconf = dashboard.get_site_usage(site)
        miscconf = get_misc_site_data(siteconf)

        saconf = miscconf
        saconf.update(usageconf)
        saconf.update(siteconf)
        
        r = self.get_response()
        for i in SA_shortcuts:
            if i.has_key('service') and filterobj.is_hidden(i['service']):
                print 'removing %s' % i['service']
            else:
                if saconf.has_key('frontpage') and int(saconf['frontpage']['enabled']) == 1:
                    if i.has_key('service'):
                        if i['service'] == 'apache':
                            i['items'] = [('Configuration', '/webhost/services/virtualhosting/siteadmin/services/apache/index_html'),
                                          ('SSL Settings', '/webhost/services/virtualhosting/siteadmin/services/apache/view_ssl', 'openssl'),
                                          ('Users', '/webhost/services/virtualhosting/siteadmin/services/apache/view_usefrontpage?fp=users'),
                                          ('Groups', '/webhost/services/virtualhosting/siteadmin/services/apache/view_usefrontpage?fp=groups'),
                                          ('Log Manager',
                                           '/webhost/services/virtualhosting/siteadmin/logrotate/'),
                                          ]
                            if not filterobj.is_hidden('subdomain'):   
                                i['items'].append(('Subdomains', 
                                             '/webhost/services/virtualhosting/siteadmin/services/subdomain/' ))


                        if i['service'] == 'files':
                            i['items']=[('Protect Directories', '/webhost/services/virtualhosting/siteadmin/services/apache/view_usefrontpage', 'apache'),
                                        ('Manage Files', '/webhost/services/virtualhosting/siteadmin/services/files/index_html', 'files'),]
                else:
                    if i.has_key('service'):
                        if i['service'] == 'apache':
                            i['items'] = [('Configuration', '/webhost/services/virtualhosting/siteadmin/services/apache/index_html'),
                                          ('SSL Settings', '/webhost/services/virtualhosting/siteadmin/services/apache/view_ssl', 'openssl'),
                                          ('Users', '/webhost/services/virtualhosting/siteadmin/services/apache/form_htpasswd'),
                                          ('Groups', '/webhost/services/virtualhosting/siteadmin/services/apache/form_htgroup'),
                                          ('Log Manager',
                                           '/webhost/services/virtualhosting/siteadmin/logrotate/'),
                                          ]

                            if not filterobj.is_hidden('subdomain'):   
                                i['items'].append(('Subdomains', 
                                             '/webhost/services/virtualhosting/siteadmin/services/subdomain/' ))

                        if i['service'] == 'files':
                            i['items'] = [('Protect Directories', '/webhost/services/virtualhosting/siteadmin/services/apache/view_security', 'apache'),
                                          ('Manage Files', '/webhost/services/virtualhosting/siteadmin/services/files/index_html', 'files'),]
                newtbl.append(i)

        # Following code had been moved to site_toolbar() as it gets loaded
        # first and not the site_shortcuts page anymore.
        #self.get_firstpage_status(self.REQUEST)
        #splash = ''
        #if self.REQUEST.has_key('showpage') and int(self.REQUEST['showpage']) == 1:
        #    splash = '''onload="javascript:window.open('new_user_form','helpWindow','resizable=no,scrollbars=no,height=400,width=480').focus();"'''
        #self.shortcut_header('/stylesheet/site.css',splash)
        self.shortcut_header('/stylesheet/site.css')

        self.load_common_translations(saconf)

        self.site_toolbar()
        self.site_system_stats(saconf,filterobj)
        self.shortcut_table(newtbl, filterobj, 'images/modhdr_bg-purp.gif')
        self.shortcut_footer()

    def site_toolbar(self):
        req = self.REQUEST
        lang = requestutil.lang_from_request(req)
        site = requestutil.get_site_from_request(req)
        r = self.get_response()
        r.write('''
    <table width="640" border="0" cellspacing="0" cellpadding="0">
      <tr>
        <td class="head">
          <table width="640" border="0" cellspacing="1" cellpadding="1">
            <tr> 
              <td class="head"> HOME</td>
            </tr>
            <tr>
              <td class="cell1" colspan="2" valign="top"> &nbsp; <a href="view_dashboard">%s</a> <img src="/webhost/red_gif" width="4" height="4"/> <b><a href="view_shortcuts">%s</a></b></td>
            </tr>
          </table>
        </td>
      </tr>
    </table>
    <p/>
    <p/>

    ''' % (self.T_('Dashboard'),
           self.T_('Shortcuts')))
        
    def site_dashboard(self):
        req = self.REQUEST
        lang = requestutil.lang_from_request(req)
        site = requestutil.get_site_from_request(req)
        r = self.get_response()
        xml_dash = self.get_xml()
        req.response.setCookie("ocw_cookie",req.cookies["ocw_cookie"],path="/menu/")
        encoding = req['ocw_charset']

        # doc::toxml() loses out on the encoding unless xmlhelper.enter_hack()
        xmlhelper.enter_hack(_charset=req['ocw_charset'])  # PRs 34152,34986,34973

        xml_text = xml_dash.site_xml(site,lang)
        # Add an splashscreen element so that XSL can check that up and display the
        # popup to the SiteAdmin

        mydoc = xml.dom.minidom.parseString(xml_text)

        rootElem = mydoc.documentElement
        splash = mydoc.createElement('splashscreen')

        splashval = mydoc.createElement('showscreen')
        self.get_firstpage_status(self.REQUEST)

        splash_value = '0'
        if self.REQUEST.has_key('showpage') and int(self.REQUEST['showpage']) == 1:
            splash_value =str( self.REQUEST['showpage'])
        splashval1 = mydoc.createTextNode(splash_value)
        splashval.appendChild(splashval1)
        splash.appendChild(splashval)

        rootElem.appendChild(splash)

        xml_text = mydoc.toxml()
        xmlhelper.exit_hack()
        output_site_xform(r, xml_text, lang, encoding)

###################### splash screen #########################
    def get_firstpage_status(self,REQUEST):
        enabled = 0
        sitesession = sessionman.getSession(REQUEST)
        if sitesession.has_key('showpage'):
            if int(sitesession['showpage'])==1:
                enabled = 1
            del sitesession['showpage']
        REQUEST['showpage'] = enabled

def output_site_xform(output_dev, xml_text, lang, encoding):
    global site_main
    cache_load_site_xsl()

    xsl_doc = libxml2.parseDoc(xml_text)
    try:
        xsl_result = site_main.applyStylesheet(xsl_doc,
                                               {'locale': "'%s'" % lang})
        # output_dev.write(site_main.saveResultToString(xsl_result))
        xsl_result.htmlSetMetaEncoding(encoding)
        output_dev.write(xsl_result.serialize())
    except:
        import traceback
        xsl_doc.freeDoc()
        traceback.print_exc(file=sys.stderr)
        return 1
    xsl_result.freeDoc()
    return 0

def test_xml(args):
    # dumps xml out that will be used to do xform
    import xmldashboard
    xml_dash = xmldashboard.create_dashboard(version='pretty2')
    print xml_dash.site_xml(args[0], args[1])

def test_xsl(args):
    import xmldashboard
    xml_dash = xmldashboard.create_dashboard(REQUEST = None,
                                             version = 'dashboard')
    output_site_xform(sys.stdout, xml_dash.site_xml(args[0], args[1]),
                      args[1], args[2])

if __name__=='__main__':
    func = eval('test_%s' % sys.argv[1])
    func(sys.argv[2:])
